package cn.net.cpzslibs.prot;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.bean.req.Prot10006ReqBean;
import cn.net.cpzslibs.prot.bean.res.Prot10006ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;


public class Prot10006ReqSalesArea extends ProtBase {
	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode10006 = 10006;
	private Gson gson;
	private Prot10006ResBean salesAreaResult;
	
	public Prot10006ReqSalesArea() {
//		this.sInspectorId = sInspectorId;
		gson = new Gson();
	}
	
	public Prot10006ResBean getSalesAreaResult(){
		return this.salesAreaResult;
	}
	
	public void dealProductSalesArea(SocketCreate create, Prot10006ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10006ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode10006, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10006, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10006, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			salesAreaResult = gson.fromJson(jsonData, Prot10006ResBean.class);
		}
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10006ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10006, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
//		sendCheckCode(dos);
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	

}
